#ifndef PORTLISTENER_H_
#define PORTLISTENER_H_

#include <QObject>
#include "qextserialport.h"

class PortListener : public QObject
{
Q_OBJECT
public:
    PortListener(const QString &portName);
    PortListener(const QString &portName,int nBaudRate, int nParity, int nBits, int nStopBits, int nFlow);
    ~PortListener();
    bool bThereIsConnection;
    bool bCheckRTS();
    bool bCheckDTR();
    bool bCheckDSR();
    bool bCheckDCD();
    void vSetRTS(bool);
    void vSetDTR(bool);
    QString qszLineStatus();

private:
    QextSerialPort *port;
    void vSetPortSettings(const QString &portName,int nBaudRate, int nParity, int nBits, int nStopBits, int nFlow);

private slots:
    void onReadyRead();
    void onDsrChanged(bool status);

public slots:
    bool bWrite(QByteArray qba);

signals:
    void vBytesRead(QByteArray);

};


#endif /*PORTLISTENER_H_*/
