#include "connecttcp.h"

connectTcp::connectTcp(QObject *parent) :
    QObject(parent)
{
    _pSocket = NULL;
    bConnected = false;
}

connectTcp::~connectTcp()
{
    vDisconnectTcp();
}

bool connectTcp::bConnectTcp()
{
    //QByteArray data; // <-- fill with data

    _pSocket = new QTcpSocket( this ); // <-- needs to be a member variable: QTcpSocket * _pSocket;
    connect( _pSocket, SIGNAL(readyRead()), SLOT(readTcpData()) );

    _pSocket->connectToHost("127.0.0.1", 42001);
    if( _pSocket->waitForConnected() ) {
       // _pSocket->write( data );
        qDebug() << "TCP connected";
        bConnected = true;
    }else{
        qDebug() << "TCP disconnected";
        bConnected = false;
    }
    return bConnected;
}

void connectTcp::vDisconnectTcp(){
    if(bConnected){
        _pSocket->close();
        disconnect(_pSocket);
        qDebug() << "Disconnected";
        bConnected = false;
    }
}

void connectTcp::readTcpData()
{
    static int nCmpt = 0;
    QByteArray data = _pSocket->readAll();
    QString qsz;
    if(data.length()){
        nCmpt++;
        qsz = trUtf8("%3 %1 %2").arg(nCmpt).arg(data.mid(4).data()).arg(data.length());
        qDebug() << qsz.toLatin1();
        int x = qsz.indexOf("\"");
        int y = qsz.indexOf("\"",x+1);
        //data = data.mid(x,y-x-1);
        //ui->etRebut->setText(data.mid(4));
        qDebug() << trUtf8("x = %1, y = %2").arg(x).arg(y).toLatin1();
        vManageReceivedData(data);
    }
}

void connectTcp::vManageReceivedData(QByteArray qbaData){
    emit vReceivedTcp(qbaData);
}

void connectTcp::sendScratchCommand(QByteArray qbaCmd){
    int n = qbaCmd.length();

    QByteArray qba;
    qba.clear();
//    qba.append(char('c'));
    qba.append(char((n >> 24) & 0xFF));
    qba.append(char((n >> 16) & 0xFF));
    qba.append(char((n >>  8) & 0xFF));
    qba.append(char(n & 0xFF));
//    qba[0] = 'c';
//    qba[1] = (n >> 24) & 0xFF;
//    qba[2] = (n >> 16) & 0xFF;
//    qba[3] = (n >> 8) & 0xFF;
//    qba[4] = n & 0xFF;
    qba.append(qbaCmd);
    qDebug() << qba.mid(4);
    _pSocket->write( qba );
}

void connectTcp::vSendTcpSwStatus(QString qszAddr,int nSw,bool bStatus){
    static int i = 0;
    QString qszA = trUtf8("sensor-update note %1 beats 0.4").arg(60 + (2*i++)),qszB;
    if(bStatus)
        qszB = trUtf8("broadcast \"%1_SW%2_pressed\"").arg(qszAddr).arg(nSw);
    else
        qszB = trUtf8("broadcast \"%1_SW%2_unpressed\"").arg(qszAddr).arg(nSw);

    sendScratchCommand(qszA.toLocal8Bit());
    sendScratchCommand(qszB.toLocal8Bit());
    //qDebug() << qszB.toLocal8Bit();
}
