#ifndef PIIODLG_H
#define PIIODLG_H

#include <QDialog>
#include <QMap>
#include <QTimer>
#include "PortListener.h"
#include "qtusbtwi.h"
#include "connecttcp.h"

#define TWI_TARGET "0x3E"

namespace Ui {
class piIODlg;
}

class piIODlg : public QDialog
{
    Q_OBJECT
    
public:
    explicit piIODlg(QWidget *parent = 0);
    ~piIODlg();
    quint8 byLastByteRead;

private slots:
    void on_checkBoxB7_clicked(bool checked);
    void on_checkBoxB6_clicked(bool checked);
    void on_checkBoxB5_clicked(bool checked);
    void on_checkBoxB4_clicked(bool checked);
    void on_checkBoxB3_clicked(bool checked);
    void on_checkBoxB2_clicked(bool checked);
    void on_checkBoxB1_clicked(bool checked);
    void on_checkBoxB0_clicked(bool checked);
    void on_checkBoxBit7_clicked(bool checked);
    void on_checkBoxBit6_clicked(bool checked);
    void on_checkBoxBit5_clicked(bool checked);
    void on_checkBoxBit4_clicked(bool checked);
    void on_checkBoxBit3_clicked(bool checked);
    void on_checkBoxBit2_clicked(bool checked);
    void on_checkBoxBit1_clicked(bool checked);
    void on_checkBoxBit0_clicked(bool checked);

    void slotPhysNameChanged(QString);
    void slotNameChanged(QString);
    void slotNewAddrTwi(QString);

    void on_checkBox_clicked(bool checked);
    void vRead();

    void on_btRead_clicked();
    void slotTimerCheckButton(bool);

    void on_checkBoxConnectScratch_clicked(bool checked);

    void vManageReceivedTcp(QByteArray);

private:
    Ui::piIODlg *ui;
    PortListener *listener;
    QMap<QString,QString> qmPortList;
    QTimer *timer;
    void vListAvailablePorts();

    qtUsbTwi *twi;
    void vUpdateCheckboxesWhenReading(quint8);
    quint8 byOutputMask();
    quint8 byOutputLeftMask();
    void vCheckBoxManagement(bool bConnected);

    connectTcp *connTCP;
};

#endif // PIIODLG_H
